# Welcome to Serrano Guides

![Logo](https://github.com/pcpLiu/Serrano/raw/master/logo.png "Serrano")


This guide site introduces the basic concepts and usage of [Serrano](https://github.com/pcpLiu/Serrano).
Serrano was developed as a tool help researchers and developers quickly implementing deep learning models on iOS and macOS.

### Design Principles
- __Like the deep learning library you used before__. Serrano aims to offer similar programing experience in Swift as popular deep learning frameworks.
- __Easy to customize.__ Adding a new Operator/Optimizer/Loss Function is simple. Create a Swift class and conform the protocol, that's it.
- __Flat architecture.__ In Serrano, we try best to reduce complex of architecture by less abstraction. You could be clear with the whole architecture by grasping few core concepts. Also in this way, we hope everyone could easily contribute to this project.

<hr>


### Support

###### Bug reports
You can open bug-related and __only__ bug-related issues in [Serrano issues](https://github.com/pcpLiu/Serrano/issues).

###### Questions and General Discussion
For any other issues, questions and discussion, please go to [SerranoExplore](https://github.com/pcpLiu/SerranoExplore). You are free to open any issue there.

Also, there's [Gitter chatting room](https://gitter.im/SerranoFramework/Lobby) where you can ask questions. 

<hr>

### Help Improve Guides
Since Serrano is under alpha-development, guides listed in this site may be outdated.
If you find any error or misleading information, you are welcome to make a PR.
For any guides improvement suggestions or better --- adding more guides --- please do not hesitate to make a PR.


